/**************************************************************

   Program Title:   IMU64X0 Monitor
   
   Program Name:  IMU64X0_Extern.h	  Version: 1.00
   
   Author:  SS	  					  Date:  Feb 22, 2013
   
   Compiled with AVR Studio 4.19.
   
   Copyright 2004-2013, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2013 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Robotics, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-robotics.com
 */
/*
 * $Log: IMU64X0_Extern.h,v $
 * Revision 1.00  2013/02/22 SS
 *    Support for ZigBee added
 * Revision 0.85  2005/07/17 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */

//  Variable declarations
extern volatile unsigned int bytesonline;
extern volatile unsigned char programmode,crc,intelbinary[34];  // length can vary
extern volatile unsigned char hexbyte[3],hexaddress[5],intelrecordcommand;
extern volatile unsigned char seconds,minutes,hours,days,month,rtcclockcnt,startloggingmode;
extern volatile unsigned char flashtype0,flashtype1,flashpageloaded;
extern volatile unsigned char flashprogrammingactive,flashpageboundarytraversed;
extern volatile unsigned char flashprogrammingactive,flashdatainbuffer,ascii[16],flashbuffer;
extern volatile unsigned char version[30],i2cmode,smartlcdstate,digitalcompassstate,ADSstate;
extern volatile unsigned char TWI_slaveAddress,TWI_masterAddress,printoutput,storageselection,fatmounted;
extern volatile unsigned char acqtoggle,onemsecond,copyright[38],dadmode,pagemode,usdpresent,microsdname[];
extern volatile unsigned char thresholdmode,thresholdcheck[12],findthresholdaverage,foundthreshold,logrestart;
extern volatile float thresholdpercent;

extern volatile unsigned char dataString[];

//extern unsigned char bufferidptr;
extern volatile unsigned char localecho,convertlftocr;

extern volatile unsigned int flashpagesize0,flashpagesize1,pagecnt;
extern volatile unsigned int intelsuperaddress,oldpage,oldbyteoffset,totalrxcnt;
extern volatile unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
extern volatile unsigned int mseccountdown1,mseccountdown2,mseccountdown3,mseccountdown4,flashcountdown;
extern volatile int  acqloopsetting,thresholdloopcnt,logrestartcnt,logrestartmax,year;
extern volatile int  logrestartcntoffset,usdfilenamenumberoffset;
extern volatile long dataacqloopcnt;

extern volatile float max_values[10], min_values[10];
extern volatile char time_tracker[15];
extern volatile char max_time_tracker0[15],max_time_tracker1[15],max_time_tracker2[15],max_time_tracker3[15];
extern volatile char max_time_tracker4[15],max_time_tracker5[15],max_time_tracker6[15],max_time_tracker7[15],max_time_tracker8[15];
extern volatile char min_time_tracker0[15],min_time_tracker1[15],min_time_tracker2[15],min_time_tracker3[15];
extern volatile char min_time_tracker4[15],min_time_tracker5[15],min_time_tracker6[15],min_time_tracker7[15],min_time_tracker8[15];
extern volatile char first_time_grav;  
extern volatile char first_time_gyro;
extern volatile char first_time_mag; 

extern volatile long endtimelong,starttimelong;

extern volatile unsigned char messageBuf[TWIMESSAGELENGTH];

// ************************
// MEMs Sensor Parameters
// ************************

// IMU6410 Parameters
extern volatile unsigned char logoutputmode,minmax_mode,armpb0,loggingmode,data2log,deviceid,dataformat;
extern volatile unsigned char deviceidtext[21],deviceidtext2[21],terminationmode,rtccnt;
extern volatile unsigned char hourstart,minutestart,secondstart,escmode,usdfilenamemode;
extern volatile int daystart;
extern volatile long timeoutperiod,elapsedtime;
extern volatile char timedstartmode;
extern volatile int xgmax,xgmin,xgmid,ygmax,ygmin,ygmid,zgmax,zgmin,zgmid;
extern volatile int defaultlograte,usdfilenamenumber,delaystarttimesec,fsynccnt;

extern volatile unsigned char srambuf[1024];  

// ADXL345 Parameters
extern volatile unsigned char defaultaccelerometerrange;

// BMA180 Parameters
extern volatile unsigned char bma180state;

// ITG3200 Parameters
extern volatile unsigned char itg3200state;

// MS5611 Parameters
extern volatile unsigned char ms5611state;
extern volatile unsigned int ms5611_c1,ms5611_c2,ms5611_c3,ms5611_c4,ms5611_c5;
extern volatile unsigned int ms5611_c6,ms5611_c7,ms5611_c8;

// BMP085 Parameters
extern volatile unsigned char BMPstate,bmp085mode,bmp085tempstate,bmp085pressurestate,bmp085state;
extern volatile unsigned int bmpac4,bmpac5,bmpac6,ibmptemperature,ibmppressure;
extern volatile int  bmpac1,bmpac2,bmpac3,bmpb1,bmpb2,bmpmb,bmpmc,bmpmd;
extern volatile int  bmp085countdown,bmpskipcount;
extern volatile long b5;
extern volatile float bmppressure,bmptemperature,pressuremin,pressuremax;

// L3G4200D parameters
extern volatile unsigned char dof10wmode,l3g4200dstate,defaultgyrorange;

// HMC5883 parameters
extern volatile unsigned char hmc5883state,defaultmagnetometerrange;

extern volatile unsigned char frameerror,dataoverrun;
extern volatile unsigned int totalbytecnt,xoncnt,xoffcnt,cursorlocation;
extern volatile long flashaddress,inteladdress,oldinteladdress;

extern volatile int _textmode;

//  UART0
extern volatile unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
extern volatile unsigned char UART_RxHead;
extern volatile unsigned char UART_RxTail;
extern volatile unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
extern volatile unsigned char UART_TxHead;
extern volatile unsigned char UART_TxTail;
extern volatile char  xoffsent, xonsent, enablexonoff, echoinchars, sendxoff;
extern volatile char  rxcnt,checkflag,rxcntmax;

// UART1
extern volatile unsigned char UART_RxBuf1[UART_RX_BUFFER_SIZE];
extern volatile unsigned char UART_RxHead1;
extern volatile unsigned char UART_RxTail1;
extern volatile unsigned char UART_TxBuf1[UART_TX_BUFFER_SIZE];
extern volatile unsigned char UART_TxHead1;
extern volatile unsigned char UART_TxTail1;
extern volatile char  xoffsent1, xonsent1, enablexonoff1, echoinchars1, sendxoff1;
extern volatile char  rxcnt1,checkflag1,rxcntmax1;
extern volatile unsigned char frameerror1,xoncnt1,xoffcnt1,dataoverrun1,totalrxcnt1;

extern volatile unsigned char  instrg[8],vlow,vhigh,defaultaccelerometerrange,logoutputmode;

extern volatile unsigned char FlashAddress[3];
extern const char signon1A[],signon1B[],signon1C[];
extern const char signon2[];
extern const char signon3[];
extern const char signon4[];
extern const char signon5[];
extern const char signon6[];
extern const char signon62[];
extern const char signon65[];
extern const char signon66[];
extern const char signon67[];
extern const char signon7[];
extern const char signon8[];
extern const char signon83[];
extern const char signon85[];
extern const char signon9[];
extern const char signon10[];

extern const char displaymessage1[];
extern const char displaymessage2[];
extern const char displaymessage3[];
extern const char displaymessage33[];

extern const char progmessage[];

extern const char displaymessage4[];
extern const char displaymessage5[];
extern const char displaymessage6[];

extern const char loadmessage1[];
extern const char loadmessage2[];
extern const char loadmessage3[];

extern const char enummes1[];
extern const char enummes8[];
extern const char enummes9[];
extern const char enummes10[];
extern const char enummes11[];
extern const char enummes12[];
extern const char enummes13[];
extern const char enummes14[];
extern const char enummes15[];
extern const char enummes16[];
extern const char enummes17[];

// Function declarations
//extern unsigned char EEPROMwrite(int,unsigned char);
//extern unsigned char EEPROMread(int);
//extern int printf(CONST char *, ...);
//extern int sprintf(char *, CONST char *, ...);
//extern int scanf(CONST char *, ...);
//extern int sscanf(char *, CONST char *, ...);

//extern struct delay_time CalculateStartTime(long delaysec);
extern void InitUART(unsigned char baudrate);
extern void InitUART1(unsigned char baudrate);
extern void InitADC(void);
extern void InitRealTimeClock(void);
extern void Init_Timer0(void);
extern void InitWatchdog(void);
extern void Init_SPI_Master(void);
extern void Init_AVR(void);
extern void Delay(void);
extern void shortdelay(int cnt);
extern void LongDelay(int cnt);
extern void Delaymsec(int delayvalue);
extern void GREEN_LED(unsigned char mode);
extern void RED_LED(unsigned char mode);
extern void WriteEEPROM(int location, unsigned char *strg);
extern void BlinkGreen(int period);
extern void BlinkRed(int period);
extern void PiranaMorse(void);
extern void EEPROMSetup(void);
extern void getsettime(char);
extern void getsetdate(char);
extern void getTime(void);
extern char getint(void);
extern unsigned char ReadAVRFlash(int address);
extern void signon(void);
extern void DisplayEEPROM(int address,int numbytes);
extern void DisplayAVRFlash(int address,int numbytes);
extern void DisplayMemory(void);
extern void DebugDisplayIntelHex(void);
extern int checkcrc(unsigned char);
extern int DecodeIntelHex(void);
extern void ProgramEEPROM(void);
extern void ProgramAVRFlash(void);
extern void ProgramMemory(void);
extern void FlashChipSelect(unsigned char mode);
extern void LoadMemory(void);
extern void ProgramVersion(void);
extern void PrintHex(unsigned char);
extern int  AnalogCh(unsigned char,char mode);
extern void DumpAnalogChs(char mode);
extern void TestAVR(void);
extern void Release_SPI(void);
extern void SPI_MasterTransmit(unsigned char cData);
extern unsigned char SPI_MasterReceive(void);
extern void ConvertFlashAddress(long address);
extern void SPI_StartReadFlashPage(unsigned int address);
extern void SPI_ReadFlashBuffer(unsigned int address,unsigned int buffernumber);
extern void EraseFlashPage(void);
extern void ProgramBuffertoPageErase(unsigned char bufferid);
extern void DisplaySerialFlash(unsigned int address,
                            unsigned int numbytes,char readmode);
extern void ProgramSerialFlash(void);
extern unsigned char SPI_SerialFlashStatus(void);
extern void CleanUpFlashState(void);
extern void Init_TWI_Master(void);
extern void Init_TWI_Slave(unsigned char slaveaddress,char generalcall);
extern void TWI_Error(void);
extern void TWI_Off(void);
extern unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
                            unsigned char statusmode);
extern unsigned char TWI_Master_Receive(unsigned char slaveaddress);
extern void TestTWI(void);
extern void TWI_Write_Slave(void);
extern unsigned char getcharnw(void);
extern void InittUART(unsigned char baudrate);
extern unsigned char ReceiveByte(void);
extern void TransmitByte(unsigned char data);
extern unsigned char getuchar(void);
extern int putchar1(unsigned char data);
extern void puts1(char *);
extern unsigned char getchar1(void);
extern unsigned char getcharnw1(void);
extern void printint(int intvalue,char charcnt,char leadchartype);
extern void putus(char *outstrg);
extern void putCRLF(void);
extern void putCRLFP(void);
extern void putfs(const char *signon1);
extern void bytetohex(unsigned char byte);
extern void addresstohex(unsigned int address);
extern unsigned char converttohex(char *instrg);
extern int readint(void);
extern long readlong(void);
extern void Init_3Axis_Accelerometer(char);
extern void putcharr(unsigned char);
extern unsigned char getcharr(void);
extern void Display_Gravity(void);
extern void WaitForFlashFree(void);
//extern int putchar(char);
extern void PrintWordHex(unsigned int);

// Nokia LCD externals
extern void Initialize_Nokia_LCD(void);
extern void Draw_Color_Bars(unsigned char color);
extern void Draw_Boxes(unsigned char color);
extern void Draw_Background(unsigned char color);
extern void Nokia_LCD_LED(unsigned char state);
extern void Nokia_LCD_ContrastUp(void);
extern void Nokia_LCD_ContrastDown(void);
extern unsigned char Read_Switched(void);
extern void ProcessLCDCommands(unsigned char);

extern void CheckFlashTypes(void);
extern void ChipErase(void);
extern void FlashChipErase(void);

extern void SaveEepromPreferences(void);
extern void LoadEepromPreferences(void);
extern void PrintEepromPreferences(void);
extern void SetDefaultEepromPreferences(void);
extern float ReadEepromFloat(int address);
extern void  WriteEepromFloat(int address,float fvalue);
extern int ReadEepromInt(int address);
extern long ReadEepromLong(int address);
extern unsigned char CheckEepromSignature(void);
extern void WriteCopyright(void);
extern void WriteVersion(void);
extern void WriteEepromInt(int address,int ivalue);
extern void WriteEepromLong(int address,long ivalue);
extern void WriteEepromSignature(void);
extern unsigned char EEPROM_read(int uiAddress);
extern void  EEPROM_write(int uiAddress,unsigned char ucData);

// TWI Extern Functions
extern void TWI_Master_Initialise(void);
extern unsigned char TWI_Transceiver_Busy(void);
extern unsigned char TWI_Get_State_Info(void);
extern void TWI_Start_Transceiver_With_Data(volatile unsigned char * , unsigned char);
extern void TWI_Start_Transceiver(void);
extern unsigned char TWI_Get_Data_From_Transceiver(volatile unsigned char *,unsigned char);
extern unsigned char TWI_Start_Read(unsigned char address,unsigned char msgSize);
extern void TWI_Start_Write(unsigned char address,volatile unsigned char *msg,unsigned char msgSize);
extern void TWI_Master_Initialize(void);

// Data Logger Functions
extern void Display_SmartLCD(void);
extern void putcharSmartLCD(char);
extern void putsSmartLCD(char *);
extern void ClearSmartLCD(void);
extern int Read_SmartLCD_Rotaryvalue(char);
extern void Enumerate_TWI_Devices(void);
extern void Execute_TWI_Command(void);
extern unsigned char Read_BMP085_EEPROM(unsigned char);
extern unsigned int Read_BMP085_Pressure(void);
extern unsigned int Read_BMP085_Temperature(void);
extern float Read_BMP085_pressurefloat(char);
extern void Load_BMP085_Parameters(void);
extern int Read_BMP085_EEPROM_Signed(unsigned char);
extern void EnableBMP085(char);
extern unsigned int Read_BMP085_EEPROM_UnSigned(unsigned char);
extern void Start_Read_BMP085_Pressure(void);
extern unsigned int Finish_Read_BMP085_Pressure(void);
extern void Start_Read_BMP085_Temperature(void);
extern unsigned int Finish_Read_BMP085_Temperature(void);
extern void Enumerate_ADS(void);
extern void Enumerate_DigitalCompass(void);
extern unsigned int Read_ADS1100(void);
extern long int Read_caliper(void);
extern void LogDataToSerialFlash(void);
extern void CheckforMEMSensors(void);
extern void LogData(int);
extern unsigned char CheckStartTime(void);
extern void BatteryVoltage(void);
extern void MeasureAnalogInputs(void);
extern unsigned long Read_MS5611_UnSigned(unsigned char address);
extern void Set_HMC5883_Range(unsigned char rangeselect);

extern unsigned char Read_HMC5883_Register(unsigned char);
extern void Write_HMC5883_Register(unsigned char,unsigned char);
extern void Enumerate_BMP085(void);
extern void Enumerate_HMC5883(void);
extern void Init_SmartLCD_TWI(unsigned char);
extern int HMC5883_ReadAxis(char);

extern void Set_L3G4200D_Range(char);
extern void Set_L3G4200D_Bandwidth(char);
extern void DumpL3G4200Registers(void);
extern void DisplayGyroL3G4200(void);
extern void Set_L3G4200D_Bandwidth(char bandwidth);
extern void Set_L3G4200D_Range(char range);
extern unsigned char SPI_L3G4200D_ID(void);
extern int SPI_L3G4200D_ReadAxis(unsigned char axisselect);
extern unsigned char SPI_L3G4200D_GetByte(unsigned char iregister);
extern void SPI_L3G4200D_PutByte(unsigned char iregister,unsigned char outbyte);
extern void L3G4200DChipSelect(unsigned char mode);

extern void DisplayADXL345Data(void);
extern unsigned char SPI_ADXL345_ID(void);
extern int SPI_ADXL345_ReadAxis(unsigned char axisselect);
extern void ADXL345_SetRange(char inchar);
extern void SPI_ADXL345_Write(unsigned char commandadd,unsigned char data);
extern void SPI_ADXL345_DataFormat(void);
extern void ADXL345ChipSelect(unsigned char mode);

extern void DOF10WMenu(void);
extern void DisplayDOF10WRegisters(unsigned char inchar);
extern char DisplayDOF10WValues(unsigned char inchar);
extern void DisplayDOF10WData(char mode);
extern void Check_BMP085_Pressure_Update(void);
extern void Check_BMP085_Temperature_Update(void);
extern void printtime(void);
extern void DisplayBMP085Brief(char mode);
extern void Init_BMP085_Readings(void);
extern void Check_BMP085_Update_Int(void);

extern void DisplayMagnetometerPlusMinus(void);
extern void DisplayMagnetometer(void);
extern float CalculateAccelScale(unsigned char);
extern float CalculateGyroScale(unsigned char);
extern float CalculateMagScale(unsigned char);

//extern float atan2(float y, float x);
extern float TruncateAccel(float accel);
extern void CheckforDOF10W(void);
extern void DumpHMC5883Regs(void);

extern void IMU6410Menu(void);
extern float CalculateBMP085Temperature(unsigned int BMPtemperature);
extern float CalculateBMP085pressurefloat(unsigned int BMPtemperature,unsigned int BMPpressure);

extern int PutChar(unsigned char indata);
extern unsigned char GetChar(void);

extern int FAT32_FileSystem_Test(void);

// Motor control functions
extern void Set_Motor_StepMode(char stepmode,char wheel);
extern void Set_Motor_Torque(char torque,char wheel);
extern void Set_Motor_Decay(char decay,char wheel);
extern void Step_Motor(long numsteps, unsigned int stepratepps,char direction,char wheel);
extern void Step_Motor_Continuously(unsigned int stepratepps, char wheel);
extern void Stop_Motor(char wheel);
extern void Mag_Drive(char state,char wheel);
extern void Set_Mag_PWM(unsigned char dutycycle, char wheel);

// DAD Variables 
extern volatile int localStorageFlag,bufferidptr,bytesinpage;
	
extern volatile int  analogValue0, analogValue1, analogValue2, analogValue3; 
extern volatile int  analogValue4, analogValue5, analogValue6, analogValue7;

extern volatile int analogSample;
extern volatile long flashaddress;

extern volatile unsigned char MuxPtr;

extern volatile unsigned char ADC0Resolution,ADC1Resolution,ADC2Resolution;
extern volatile unsigned char ADC3Resolution,ADC4Resolution,ADC5Resolution;
extern volatile unsigned char ADC6Resolution,ADC7Resolution;

extern volatile unsigned char ADC0Exists,ADC1Exists,ADC2Exists,ADC3Exists;
extern volatile unsigned char ADC4Exists,ADC5Exists,ADC6Exists,ADC7Exists;

extern volatile unsigned char Digi0Exists,Digi1Exists,Digi2Exists,Digi3Exists;
extern volatile unsigned char Digi4Exists,Digi5Exists,Digi6Exists,Digi7Exists;
extern volatile unsigned char Digi8Exists,Digi9Exists,Digi10Exists,Digi11Exists;
extern volatile unsigned char Digi12Exists,Digi13Exists,Digi14Exists,localStorage;

extern volatile int StartPin;
extern volatile int StartPort;
extern volatile int StartThresholdFlag;
extern volatile int StartThresholdValue;
extern volatile int StartThresholdPin;

extern volatile int StopPin;
extern volatile int StopPort;
extern volatile int StopPinFlag;
extern volatile int StopThresholdFlag;
extern volatile int StopThresholdValue;
extern volatile int StopThresholdPin;

extern volatile unsigned int startCondition;
extern volatile unsigned int EndCondition;

extern volatile unsigned int milSecTimer0, milSecTimer1, milSecTimer2, milSecTimer3;
extern volatile unsigned int milSecTimer4, milSecTimer5, milSecTimer6, milSecTimer7;

extern volatile int SampleRate0, SampleRate1, SampleRate2, SampleRate3;
extern volatile int SampleRate4, SampleRate5, SampleRate6, SampleRate7; 

extern volatile int DigiSampleRate0, DigiSampleRate1, DigiSampleRate2, DigiSampleRate3;
extern volatile int DigiSampleRate4, DigiSampleRate5, DigiSampleRate6, DigiSampleRate7;
extern volatile int DigiSampleRate8, DigiSampleRate9, DigiSampleRate10, DigiSampleRate11;
extern volatile int DigiSampleRate12, DigiSampleRate13, DigiSampleRate14;

extern volatile unsigned int DigiMilSecTimer0,DigiMilSecTimer1,DigiMilSecTimer2,DigiMilSecTimer3;
extern volatile unsigned int DigiMilSecTimer4,DigiMilSecTimer5,DigiMilSecTimer6,DigiMilSecTimer7;
extern volatile unsigned int DigiMilSecTimer8,DigiMilSecTimer9,DigiMilSecTimer10,DigiMilSecTimer11;
extern volatile unsigned int DigiMilSecTimer12,DigiMilSecTimer13,DigiMilSecTimer14;

extern void checkStopThreshold(void);
extern unsigned int  ScanInt(void);
extern void Check_Acq_Loop_led(void);
extern void dataAcquisition(void);
extern void testing(void);
extern void Inactivate_Analog(void);
extern void Dump_Init_Channel_Config(void);
extern void Init_Channel_Config(void);
extern void SetEndCondition(void);
extern void SetStartCondition(void);
extern void Inactivate_All_Channels(void);
extern void Activate_Channel(void);
extern void AssignConfigToChannel(int resolution,int sampleRate,int pinType,int pinNumber);
extern void channelConfigReceiver(void);
extern void Scheduler(void);
extern void checkStopPinHigh(void);
extern void checkStopPinLow(void);
extern void checkStartPinHigh(void);
extern void checkStartPinLow(void);
extern void checkStartThreshold(void);
extern void GetLoggedData(void);
extern void ChipErase(void);
extern void WaitForFlashFree(void);
extern char FlashBlankCheck(void);
extern void Write_Test_Data(void);
extern void DisplayGravity(void);

//End of DAD Variables 

// Zigbee functions
extern void set2Time(void);
extern void get2Time(void);
extern void set2Date(void);
extern void get2Date(void);
extern void initZigbeeSlave(void);
extern int zNodeFinder(void);
extern void checkZigbee(void);
extern void ZigbeeSurvey(void);
extern void UploadZigData(void);
extern int WaitForOKERROR(char mode,int maxdelayperiod);


